import { Component, Inject } from '@angular/core';
import { Http } from '@angular/http';
import { IgGridComponent } from 'igniteui-angular2';
import { HomeService } from './home.service';
import { IHome } from './home';

declare var $: any;
@Component({
    selector: 'home',
    templateUrl: './home.component.html',
    providers: [HomeService]
})
export class HomeComponent {
    private gridOptions: IgGrid;
    private id: string;
    private errorMessage: string;
    private gridHome: IHome[] = [];
    private users: any[] = [];

    ngOnInit(): void {



        this._homeService.getHome()
            .subscribe(data => {
                this.gridHome = data;

            },
            error => this.errorMessage = <any>error);


        this._homeService.getUsers()
            .subscribe(data => {
                this.users = data;

            },
            error => this.errorMessage = <any>error);



    }

    constructor(private _homeService: HomeService) {
        var me = this;

        //this.data = this.ErrorTypes;
        this.id = 'TestTypeGrid';
        this.gridOptions = {

            //autoCommit: true,
            dataSource: this.gridHome,
            width: "100%",
            height: "710px",
            autoGenerateColumns: false,
           
            rendered: (e, ui) => {
                //ui.owner.dataSource.settings.restSettings.contentType = undefined;
                //$.ajaxSetup({
                //    url: "",
                //    xhrFields: {
                //        withCredentials: true
                //    }
                //})
            },
            columns: [
                { key: "userId", headerText: "userId", width: "20%", dataType: "number" },
                { key: "id", headerText: "id", width: "20%", dataType: "number" },
                { key: "title", headerText: "title", width: "20%", dataType: "string" },
                { key: "body", headerText: "body", width: "60%", dataType: "string" },
            ],  
            primaryKey: "id",
            features: [
                {
                    name: "Updating",
                    editMode: "dialog",
                    rowEditDialogAfterOpen: function (e, ui) {

                        $("#customValidator").igValidator("addField", { selector: $("input[data-editor-for-userId]") });

                    },
                    editRowStarted: function (evt, ui) {
                        //var editor = $("#TestTypeGrid").igGridUpdating("editorForKey", "userId");
                            //if (editor) {
                            //    editor.igCombo("option", "dataSource", me.users);
                            //    editor.igCombo("dataBind");
                            //}
                    },
                    columnSettings: [
                        { columnKey: "id", readOnly: true, editorType: 'text' },
                        {
                            columnKey: "userId",
                            editorType: 'text',
                            required: true,
                            editorOptions: {
                                validatorOptions: {
                                    custom: {
                                        method: function (value, fieldOps) {
                                            me._homeService.validateUser(value)
                                                .subscribe(data => {
                                                    if (data) {
                                                        return true;
                                                    }
                                                    else {
                                                        return false;
                                                    }
                                                })
                                        },
                                        errorMessage: "user doesn't exist"
                                    }
                                },
                            }
                            //editorOptions: {
                            //    mode: "dropdown",
                            //    dataSource: this.users,
                            //    textKey: "name",
                            //    valueKey: "id",
                               
                            //}
                        }
                    ]
                },
                {
                    name: "Paging"
                },
                {
                    name: "Filtering"
                },
                {
                    name: "Sorting"
                }
            ]
        }
    }


    public saveGrid() {

        var transactions = $("#TestTypeGrid").igGrid("pendingTransactions");
        for (let transaction of transactions) {
            if (transaction.type == "newrow") {

            } else if (transaction.type == "deleterow") {

            } else {

            }
        }

        //$("#TestTypeGrid").igGrid("saveChanges", function (data) {

        //    $("#message").text("Changes were saved successfully").fadeIn(15000).fadeOut(15000);
        //    //temp1.tempPrimaryKey = -1;
        //},
        //    function (jqXHR, settings, textStatus, errorThrown) {

        //    });

    }

}
